"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOption = exports.useEvent = exports.useNonInitialEffect = exports.usePrevious = exports.useForceUpdate = void 0;
var react_1 = require("react");
function useForceUpdate() {
    var _a = __read((0, react_1.useState)(0), 2), _ = _a[0], setForceUpdateValue = _a[1];
    return function () { return setForceUpdateValue(function (value) { return value + 1; }); };
}
exports.useForceUpdate = useForceUpdate;
function usePrevious(value) {
    var ref = (0, react_1.useRef)();
    (0, react_1.useEffect)(function () {
        ref.current = value;
    });
    return ref.current;
}
exports.usePrevious = usePrevious;
function useNonInitialEffect(effect, deps) {
    var initialRender = (0, react_1.useRef)(true);
    (0, react_1.useEffect)(function () {
        var effectReturns = function () { };
        if (initialRender.current) {
            initialRender.current = false;
        }
        else {
            effectReturns = effect();
        }
        if (effectReturns && typeof effectReturns === 'function') {
            return effectReturns;
        }
    }, deps);
}
exports.useNonInitialEffect = useNonInitialEffect;
function useEvent(component, event, prev, prop) {
    (0, react_1.useEffect)(function () {
        if (component.current) {
            if (prev) {
                component.current.off(event, prev);
            }
            if (prop) {
                component.current.on(event, prop);
            }
        }
    }, [prop]);
}
exports.useEvent = useEvent;
function useOption(component, key, prop) {
    useNonInitialEffect(function () {
        if (component.current) {
            component.current.setOption(key, prop);
        }
    }, [prop]);
}
exports.useOption = useOption;
