import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef } from 'react';
import ObjectViewer from './index';
import each from 'licia/each';
import clone from 'licia/clone';
import { useNonInitialEffect } from '../share/hooks';
const LunaObjectViewer = (props) => {
    const objectViewerRef = useRef(null);
    const objectViewer = useRef();
    useEffect(() => {
        objectViewer.current = new ObjectViewer(objectViewerRef.current, clone(props));
        return () => objectViewer.current?.destroy();
    }, []);
    each(['theme', 'object', 'prototype', 'unenumerable', 'accessGetter'], (key) => {
        useNonInitialEffect(() => {
            if (objectViewer.current) {
                objectViewer.current.setOption(key, props[key]);
            }
        }, [props[key]]);
    });
    return (_jsx("div", { className: props.className || '', style: props.style, ref: objectViewerRef }));
};
export default LunaObjectViewer;
